package com.dl.shell.reflux.silentdownload;

interface IDownloadFileCallbacks {
    /**
     * handle the progress update
     * @param url: the file url being download
     * @param thisTimeReadSize: this time the size we download
     * @param haveDownloadSize: now the size we have download
     * @param totalSize: the file total size we are downloading
     */
    void onDownloadProgressUpdate(String url, int thisTimeReadSize,
        long haveDownloadSize, long totalSize);

    void onStartDownload(String url);

    /**
     * handle the download completed event
     *
     * @param haveDownloadSize: now the size we have download
     */
    void onDownloadSucceed(String pkgName, String url, long haveDownloadSize);

    /**
     * handle the download failed events
     * @param errorCode: see the error code above, the code name will
     *            indicate their intent.
     * @param haveDownloadSize: now we have download
     */
    void onDownloadFailed(String url, int errorCode, long haveDownloadSize);

    /**
     * when the download process stopped, handle the cancel events
     * @param haveDownloadSize: now we have download
     */
    void onDownloadCanceled(String url, long haveDownloadSize);
}